from twisted.trial.unittest import TestCase
from twisted.python.failure import Failure
from tada import Tada

class SQLiteTest(TestCase):
    def test_ConnectFail(self):
        return Tada("pysqlite2.dbapi2").connect("/tmp/d/i/e/n/o/w/").addBoth(lambda _: True)

    def test_ConnectPass(self):
        def cursorContext(cursor):
            return True
        return Tada("pysqlite2.dbapi2").connect(self.mktemp()).addCallback(cursorContext)

    def test_GetCursor(self):
        def gotCursor(cursor):
            from pysqlite2.dbapi2 import Cursor
            self.assertEquals(cursor.__tada_cursor__.__class__,Cursor)
            return True
        def gotConnection(connection):
            return connection.cursor().addCallback(gotCursor)
        return Tada("pysqlite2.dbapi2").connect(self.mktemp()).addCallback(gotConnection)
