from twisted.python.failure import Failure
from twisted.internet import defer

class GenAsidePayloadLost(Exception):
    pass

class GenAside(object):
    def __init__(self,returnValue=None):
        self.returnValue = returnValue
        self.deferal = defer.Deferred()
    def checkPayload(self):    
        if hasattr(self,'pendingResult'): raise GenAsidePayloadLost, str(self.pendingResult)
    @property
    def result(self):
        if hasattr(self,'pendingResult'):
            self.previousPending=self.pendingResult
            del self.pendingResult
        if isinstance(self.previousPending,Failure):
            raise self.previousPending.value,self.previousPending.type
        else:
            return self.previousPending
    def resultCallback(self,res):
        self.checkPayload()
        self.pendingResult = res
        try:
            self.generator.next().addBoth(self.resultCallback)
        except StopIteration:
            self.deferal.callback(self.returnValue)
    def _return(self,res=None):
        self.returnValue = res
        raise StopIteration

def genAside(func):
    def wrapper(*args,**kwargs):
        gen = GenAside()
        gen.generator = func(gen,*args,**kwargs)
        gen.resultCallback(None); gen.result
        return gen.deferal
    return wrapper

# Decorators
def preGetCursor(func):    
    """ The class using this needs to have self.dbapi """
    def wrapper(self,*args,**kwargs):
        def gotCursor(cursor):
            return func(cursor,self,*args,**kwargs)
        return self.dbapi.cursor().addCallback(gotCursor)
    return wrapper
